/* A Bison parser, made by GNU Bison 3.0.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 22 "cfgparser1.y" /* yacc.c:339  */


#include <stdio.h>
#ifdef HAVE_STDLIB_H
# include <stdlib.h>
#endif
#ifdef HAVE_STRING_H
# include <string.h>
#endif
#include "conf.h"
#include "debug.h"

#define YYDEBUG 1
#define YYERROR_VERBOSE 1

void yyerror(const char *s);
int yylex(void);

extern FILE *yyin, *yyout;
struct config cur_config;
struct alarm_cfg *cur_alarm;
struct target_cfg *cur_target;



#line 92 "cfgparser1.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_CFGPARSER_H_INCLUDED
# define YY_YY_CFGPARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TIME = 258,
    INTEGER = 259,
    STRING = 260,
    DEBUG = 261,
    USER = 262,
    GROUP = 263,
    PID_FILE = 264,
    MAILER = 265,
    TIMESTAMP_FORMAT = 266,
    RRD = 267,
    STATUS = 268,
    ALARM = 269,
    TARGET = 270,
    OVERRIDE = 271,
    DEFAULT = 272,
    MAILTO = 273,
    MAILFROM = 274,
    MAILENVFROM = 275,
    MAILSUBJECT = 276,
    COMMAND = 277,
    PIPE = 278,
    COMBINE = 279,
    REPEAT = 280,
    DOWN = 281,
    LOSS = 282,
    DELAY = 283,
    TIME_ = 284,
    PERCENT_LOW = 285,
    PERCENT_HIGH = 286,
    DELAY_LOW = 287,
    DELAY_HIGH = 288,
    DESCRIPTION = 289,
    SRCIP = 290,
    ALARMS = 291,
    INTERVAL = 292,
    AVG_DELAY_SAMPLES = 293,
    AVG_LOSS_SAMPLES = 294,
    AVG_LOSS_DELAY_SAMPLES = 295,
    FILE_ = 296,
    SCRIPTFORMAT = 297,
    ERROR = 298,
    ON = 299,
    OFF = 300,
    YES = 301,
    NO = 302,
    TRUE = 303,
    FALSE = 304
  };
#endif
/* Tokens.  */
#define TIME 258
#define INTEGER 259
#define STRING 260
#define DEBUG 261
#define USER 262
#define GROUP 263
#define PID_FILE 264
#define MAILER 265
#define TIMESTAMP_FORMAT 266
#define RRD 267
#define STATUS 268
#define ALARM 269
#define TARGET 270
#define OVERRIDE 271
#define DEFAULT 272
#define MAILTO 273
#define MAILFROM 274
#define MAILENVFROM 275
#define MAILSUBJECT 276
#define COMMAND 277
#define PIPE 278
#define COMBINE 279
#define REPEAT 280
#define DOWN 281
#define LOSS 282
#define DELAY 283
#define TIME_ 284
#define PERCENT_LOW 285
#define PERCENT_HIGH 286
#define DELAY_LOW 287
#define DELAY_HIGH 288
#define DESCRIPTION 289
#define SRCIP 290
#define ALARMS 291
#define INTERVAL 292
#define AVG_DELAY_SAMPLES 293
#define AVG_LOSS_SAMPLES 294
#define AVG_LOSS_DELAY_SAMPLES 295
#define FILE_ 296
#define SCRIPTFORMAT 297
#define ERROR 298
#define ON 299
#define OFF 300
#define YES 301
#define NO 302
#define TRUE 303
#define FALSE 304

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 51 "cfgparser1.y" /* yacc.c:355  */

	int i;
	char *s;
	struct alarm_cfg *a;
	struct target_cfg *t;
	struct config *c;
	struct alarm_list *al;

#line 239 "cfgparser1.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;
int yyparse (void);

#endif /* !YY_YY_CFGPARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 268 "cfgparser1.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  34
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   187

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  55
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  19
/* YYNRULES -- Number of rules.  */
#define YYNRULES  80
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  150

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   304

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      53,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    52,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    54,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    50,     2,    51,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   124,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   144,   147,   150,   156,   162,
     163,   168,   173,   180,   181,   184,   185,   187,   189,   192,
     193,   195,   197,   200,   201,   203,   206,   207,   209,   211,
     213,   215,   220,   222,   224,   229,   231,   233,   235,   237,
     242,   243,   250,   251,   253,   255,   257,   259,   261,   263,
     265,   267,   269,   271,   274,   276,   280,   281,   283,   285,
     287,   289,   293,   296,   297,   298,   299,   300,   301,   304,
     305
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TIME", "INTEGER", "STRING", "DEBUG",
  "USER", "GROUP", "PID_FILE", "MAILER", "TIMESTAMP_FORMAT", "RRD",
  "STATUS", "ALARM", "TARGET", "OVERRIDE", "DEFAULT", "MAILTO", "MAILFROM",
  "MAILENVFROM", "MAILSUBJECT", "COMMAND", "PIPE", "COMBINE", "REPEAT",
  "DOWN", "LOSS", "DELAY", "TIME_", "PERCENT_LOW", "PERCENT_HIGH",
  "DELAY_LOW", "DELAY_HIGH", "DESCRIPTION", "SRCIP", "ALARMS", "INTERVAL",
  "AVG_DELAY_SAMPLES", "AVG_LOSS_SAMPLES", "AVG_LOSS_DELAY_SAMPLES",
  "FILE_", "SCRIPTFORMAT", "ERROR", "ON", "OFF", "YES", "NO", "TRUE",
  "FALSE", "'{'", "'}'", "','", "'\\n'", "';'", "$accept", "config",
  "makealarm", "maketarget", "getdefalarm", "getdeftarget", "alarm",
  "alarmcommoncfg", "alarmlosscfg", "alarmdelaycfg", "alarmdowncfg",
  "alarmcommon", "target", "targetcfg", "alarmlist", "statuscfg", "string",
  "boolean", "separator", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     123,   125,    44,    10,    59
};
# endif

#define YYPACT_NINF -59

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-59)))

#define YYTABLE_NINF -19

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     103,   -59,   -14,    21,    21,    21,    21,    21,    -1,    10,
      36,    38,    25,   -59,   -59,   -59,   -59,   -59,   -59,   -59,
     -59,   -59,   -59,   -59,   -59,   -59,   -59,   -59,    69,     2,
      20,    59,    21,    79,   -59,   -59,   -59,   103,   -59,    77,
      21,   -14,   -30,    21,    21,    21,    50,    57,    84,    41,
     -59,   -59,   -59,   -59,   -59,     2,    86,    90,    95,   141,
      85,    85,    41,   129,   108,    -5,    21,    21,    21,    21,
       5,     7,   132,   143,     3,   -59,   114,    21,    21,     6,
     102,   164,   167,   168,     8,    31,   170,    35,   -59,   171,
     172,    39,   -59,   174,   175,   116,   -59,   -59,   -59,   -59,
     -59,    21,    21,   -59,    21,    21,   -59,   -59,   176,   -59,
     141,    21,   -59,   -59,    21,   122,   -59,   -59,   -59,   -59,
     -59,   -59,   -59,    85,   -59,   -59,   -59,   129,   -59,   -59,
     -59,   108,   -59,   -59,   -59,    -5,   -59,   -59,   -59,   -59,
     -59,    41,   -59,   122,    21,    41,    41,    41,    41,   -59
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    14,     0,     0,     0,     0,     0,     0,     0,     0,
      15,    16,     0,    11,    12,    73,    74,    75,    76,    77,
      78,     3,    72,     4,     5,     8,     6,     7,     0,    66,
       0,     0,     0,     0,     1,    79,    80,     0,    10,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    13,
      69,    68,    67,    70,     9,    66,     0,     0,     0,    36,
      52,    52,    71,    36,    36,    36,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    23,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    33,     0,
       0,     0,    25,     0,     0,     0,    29,    37,    38,    39,
      40,     0,     0,    41,     0,     0,    44,    47,    49,    19,
      36,     0,    53,    54,     0,    55,    64,    58,    57,    59,
      60,    61,    51,    52,    50,    34,    20,    36,    26,    27,
      21,    36,    30,    31,    22,    36,    42,    43,    45,    46,
      48,    24,    62,    56,     0,    63,    35,    28,    32,    65
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -59,   142,   -59,   -59,   -59,   -59,   -59,    71,    51,    48,
      58,   -58,   -59,   -52,    70,   131,    -3,   146,    -4
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    12,    30,    32,    31,    33,    13,    74,    91,    95,
      87,    75,    14,    84,   115,    42,   116,    21,   123
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      23,    24,    25,    26,    27,    88,    92,    96,    37,    85,
      22,    22,    22,    66,    67,    68,    69,    70,    71,    72,
      73,    54,   114,    35,    36,    34,    22,    93,    94,    47,
      15,    16,    17,    18,    19,    20,    28,    52,    55,    39,
      56,    57,    58,    40,    41,    37,    43,    44,    45,   101,
     102,   104,   105,   -17,   109,   -18,    35,    36,    55,   122,
      29,    35,    36,    97,    98,    99,   100,   103,   106,    88,
     110,   145,    38,    92,   112,   113,    46,    96,    35,    36,
      50,    51,   124,   127,    35,    36,   126,   131,    35,    36,
     130,   135,    35,    36,    35,    36,    48,    76,   136,   137,
      59,   138,   139,    -2,     1,   117,   118,    60,   142,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    77,
      78,    79,    80,    81,    82,    83,    66,    67,    68,    69,
      70,    71,    72,    73,    61,   107,    63,   110,    89,    90,
      64,   149,   127,   131,   135,    65,   108,    66,    67,    68,
      69,    70,    71,    72,    73,   111,    -2,    -2,    86,    66,
      67,    68,    69,    70,    71,    72,    73,   134,   119,    35,
      36,   120,   121,   125,   144,   128,   129,   132,   133,    49,
     140,   141,   147,   148,   143,   146,    62,    53
};

static const yytype_uint8 yycheck[] =
{
       3,     4,     5,     6,     7,    63,    64,    65,    12,    61,
       5,     5,     5,    18,    19,    20,    21,    22,    23,    24,
      25,    51,    16,    53,    54,     0,     5,    32,    33,    32,
      44,    45,    46,    47,    48,    49,    37,    40,    42,    37,
      43,    44,    45,    41,    42,    49,    26,    27,    28,    44,
      45,    44,    45,    17,    51,    17,    53,    54,    62,    51,
      50,    53,    54,    66,    67,    68,    69,    70,    71,   127,
      74,   123,     3,   131,    77,    78,    17,   135,    53,    54,
       3,     4,    51,    87,    53,    54,    51,    91,    53,    54,
      51,    95,    53,    54,    53,    54,    17,    12,   101,   102,
      50,   104,   105,     0,     1,     3,     4,    50,   111,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    34,
      35,    36,    37,    38,    39,    40,    18,    19,    20,    21,
      22,    23,    24,    25,    50,     3,    50,   141,    30,    31,
      50,   144,   146,   147,   148,    50,     3,    18,    19,    20,
      21,    22,    23,    24,    25,    41,    53,    54,    29,    18,
      19,    20,    21,    22,    23,    24,    25,    51,     4,    53,
      54,     4,     4,     3,    52,     4,     4,     3,     3,    37,
       4,   110,   131,   135,   114,   127,    55,    41
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    56,    61,    67,    44,    45,    46,    47,    48,
      49,    72,     5,    71,    71,    71,    71,    71,    37,    50,
      57,    59,    58,    60,     0,    53,    54,    73,     3,    37,
      41,    42,    70,    26,    27,    28,    17,    71,    17,    56,
       3,     4,    71,    72,    51,    73,    71,    71,    71,    50,
      50,    50,    70,    50,    50,    50,    18,    19,    20,    21,
      22,    23,    24,    25,    62,    66,    12,    34,    35,    36,
      37,    38,    39,    40,    68,    68,    29,    65,    66,    30,
      31,    63,    66,    32,    33,    64,    66,    71,    71,    71,
      71,    44,    45,    71,    44,    45,    71,     3,     3,    51,
      73,    41,    71,    71,    16,    69,    71,     3,     4,     4,
       4,     4,    51,    73,    51,     3,    51,    73,     4,     4,
      51,    73,     3,     3,    51,    73,    71,    71,    71,    71,
       4,    62,    71,    69,    52,    68,    65,    63,    64,    71
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    55,    56,    56,    56,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    56,    57,    58,    59,    60,    61,
      61,    61,    61,    62,    62,    63,    63,    63,    63,    64,
      64,    64,    64,    65,    65,    65,    66,    66,    66,    66,
      66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
      67,    67,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    68,    69,    69,    70,    70,    70,    70,
      70,    70,    71,    72,    72,    72,    72,    72,    72,    73,
      73
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     4,
       3,     1,     1,     3,     1,     0,     0,     0,     0,     6,
       7,     7,     7,     1,     3,     1,     2,     2,     3,     1,
       2,     2,     3,     1,     2,     3,     0,     2,     2,     2,
       2,     2,     3,     3,     2,     3,     3,     2,     3,     2,
       6,     6,     0,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     3,     3,     1,     3,     0,     2,     2,     2,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 125 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.debug=(yyvsp[0].i); }
#line 1553 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 4:
#line 126 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.user=(yyvsp[0].s); }
#line 1559 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 5:
#line 127 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.group=(yyvsp[0].s); }
#line 1565 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 6:
#line 128 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.mailer=(yyvsp[0].s); }
#line 1571 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 7:
#line 129 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.timestamp_format=(yyvsp[0].s); }
#line 1577 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 8:
#line 130 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.pid_file=(yyvsp[0].s); }
#line 1583 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 10:
#line 132 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.rrd_interval=(yyvsp[0].i); }
#line 1589 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 14:
#line 137 "cfgparser1.y" /* yacc.c:1646  */
    {
			logit("Configuration file syntax error. Line %i, character %i",
					(yyloc).first_line+1,(yyloc).first_column+1);
			YYABORT;
		}
#line 1599 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 15:
#line 144 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.a)=make_alarm(); }
#line 1605 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 16:
#line 147 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.t)=make_target(); }
#line 1611 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 17:
#line 150 "cfgparser1.y" /* yacc.c:1646  */
    { 
	   		(yyval.a)=&cur_config.alarm_defaults; 
			cur_alarm=(yyval.a);
	   	}
#line 1620 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 18:
#line 156 "cfgparser1.y" /* yacc.c:1646  */
    { 
	    		(yyval.t)=&cur_config.target_defaults; 
			cur_target=(yyval.t);
		}
#line 1629 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 20:
#line 164 "cfgparser1.y" /* yacc.c:1646  */
    { 
			cur_alarm->name=(yyvsp[-3].s);
			add_alarm(AL_DOWN); 
		}
#line 1638 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 21:
#line 169 "cfgparser1.y" /* yacc.c:1646  */
    { 
			cur_alarm->name=(yyvsp[-3].s);
			add_alarm(AL_LOSS); 
		}
#line 1647 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 22:
#line 174 "cfgparser1.y" /* yacc.c:1646  */
    { 
			cur_alarm->name=(yyvsp[-3].s);
			add_alarm(AL_DELAY); 
		}
#line 1656 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 26:
#line 186 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->p.lh.low=(yyvsp[0].i); }
#line 1662 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 27:
#line 188 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->p.lh.high=(yyvsp[0].i); }
#line 1668 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 30:
#line 194 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->p.lh.low=(yyvsp[0].i); }
#line 1674 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 31:
#line 196 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->p.lh.high=(yyvsp[0].i); }
#line 1680 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 34:
#line 202 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->p.val=(yyvsp[0].i); }
#line 1686 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 37:
#line 208 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->mailto=(yyvsp[0].s); }
#line 1692 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 38:
#line 210 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->mailfrom=(yyvsp[0].s); }
#line 1698 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 39:
#line 212 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->mailenvfrom=(yyvsp[0].s); }
#line 1704 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 40:
#line 214 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->mailsubject=(yyvsp[0].s); }
#line 1710 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 41:
#line 216 "cfgparser1.y" /* yacc.c:1646  */
    { 
			if (cur_alarm->command_on==NULL) cur_alarm->command_on=(yyvsp[0].s); 
			if (cur_alarm->command_off==NULL) cur_alarm->command_off=(yyvsp[0].s); 
		}
#line 1719 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 42:
#line 221 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->command_on=(yyvsp[0].s); }
#line 1725 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 43:
#line 223 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->command_off=(yyvsp[0].s); }
#line 1731 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 44:
#line 225 "cfgparser1.y" /* yacc.c:1646  */
    { 
			if (cur_alarm->pipe_on==NULL) cur_alarm->pipe_on=(yyvsp[0].s); 
			if (cur_alarm->pipe_off==NULL) cur_alarm->pipe_off=(yyvsp[0].s); 
		}
#line 1740 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 45:
#line 230 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->pipe_on=(yyvsp[0].s); }
#line 1746 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 46:
#line 232 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->pipe_off=(yyvsp[0].s); }
#line 1752 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 47:
#line 234 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->combine_interval=(yyvsp[0].i); }
#line 1758 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 48:
#line 236 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->repeat_interval=(yyvsp[-1].i); cur_alarm->repeat_max=(yyvsp[0].i); }
#line 1764 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 49:
#line 238 "cfgparser1.y" /* yacc.c:1646  */
    { cur_alarm->combine_interval=(yyvsp[0].i); cur_alarm->repeat_max=0;}
#line 1770 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 51:
#line 244 "cfgparser1.y" /* yacc.c:1646  */
    { 
			cur_target->name=(yyvsp[-3].s);
			add_target(); 
		}
#line 1779 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 53:
#line 252 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->description=(yyvsp[0].s); }
#line 1785 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 54:
#line 254 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->srcip = (yyvsp[0].s); }
#line 1791 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 55:
#line 256 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->alarms=(yyvsp[0].al); }
#line 1797 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 56:
#line 258 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->alarms_override=1; cur_target->alarms=(yyvsp[0].al); }
#line 1803 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 57:
#line 260 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->interval=(yyvsp[0].i); }
#line 1809 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 58:
#line 262 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->interval=(yyvsp[0].i); }
#line 1815 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 59:
#line 264 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->avg_delay_samples=(yyvsp[0].i); }
#line 1821 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 60:
#line 266 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->avg_loss_samples=(yyvsp[0].i); }
#line 1827 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 61:
#line 268 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->avg_loss_delay_samples=(yyvsp[0].i); }
#line 1833 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 62:
#line 270 "cfgparser1.y" /* yacc.c:1646  */
    { cur_target->rrd_filename=(yyvsp[0].s); }
#line 1839 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 64:
#line 275 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.al)=alarm2list((yyvsp[0].s),NULL); }
#line 1845 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 65:
#line 277 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.al)=alarm2list((yyvsp[0].s),(yyvsp[-2].al)); }
#line 1851 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 67:
#line 282 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.status_file=(yyvsp[0].s); }
#line 1857 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 68:
#line 284 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.status_interval=(yyvsp[0].i); }
#line 1863 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 69:
#line 286 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.status_interval=(yyvsp[0].i); }
#line 1869 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 70:
#line 288 "cfgparser1.y" /* yacc.c:1646  */
    { cur_config.status_format=(yyvsp[0].i); }
#line 1875 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 72:
#line 293 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.s)=pool_strdup(&cur_config.pool,(yyvsp[0].s)); }
#line 1881 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 73:
#line 296 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.i)=1; }
#line 1887 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 74:
#line 297 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.i)=0; }
#line 1893 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 75:
#line 298 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.i)=1; }
#line 1899 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 76:
#line 299 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.i)=0; }
#line 1905 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 77:
#line 300 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.i)=1; }
#line 1911 "cfgparser1.c" /* yacc.c:1646  */
    break;

  case 78:
#line 301 "cfgparser1.y" /* yacc.c:1646  */
    { (yyval.i)=0; }
#line 1917 "cfgparser1.c" /* yacc.c:1646  */
    break;


#line 1921 "cfgparser1.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 309 "cfgparser1.y" /* yacc.c:1906  */

void yyerror (const char *s) {
	logit("%s", s);
}

